
# BW Coupon

=== Plugin Name ===


![logo](https://calantas.org/bw-coupon/raw/c0f6fd948c527afd132fdc476e1d3f0a9c5dd5fb/assets/img/banner-600x256.png)

## Requirements
 * PHP version 7.1 or higher
 * DOM extension
 * MBString extension
 * php-font-lib
 * php-svg-lib
 * curl_exec must be enabled for external image load


## Description

This plugin lets WooCommerce users to purchase coupons as any other product. Sellers can define coupons to be sold as any others products. Coupons may be automatically generated and delivered to customers as PDF attachments.


## Features ##

* WooCommerce Coupons can be purchased like any other product.

* Fully customizable coupon PDF can be designed in the WP Editor, using the Media Manager.

* The PDF can include placeholders, such as [coupon_code], [coupon_expire_date], [coupon_issue_date] and [coupon_amount].

* After the purchase, coupons can be generated and activated automatically or manually.

* Coupon PDF's are integrated into the list of coupons within WooCommerce.

* Developer is friendly :) and open for your requests.


## Support and new feature requests:

Email: veto@myridia.com

Chat: veto@jabber.calantas.com

Forum: [https://forum.calantas.com/index.php?action=vtopic&forum=1](https://forum.calantas.com/index.php?action=vtopic&forum=1)

Donation: [https://www.paypal.me/donate217](https://www.paypal.me/donate217)





## Source Repository

The main repository is on:
[https://calantas.org/bw-coupon/](https://calantas.org/bw-coupon)

You can checkout the Source Code with:

```shell
git clone https://calantas.org/bw-coupon/
```


## Motivation

This BW Coupon plugin is the beginning of an alternative way to purchase products online, via coupons instead money.

## Installation

Below you can find code examples and explanations of how to get started with the project.

## How to setup 
### 1. Click BW Coupon Settings, under the WooCommerce menu

![logo](https://calantas.org/bw-coupon/raw/c0f6fd948c527afd132fdc476e1d3f0a9c5dd5fb/docs/BWC_Settings-1.png)

### 2. Basic setup of the BW Coupon plugin
![logo]/(https://calantas.org/bw-coupon/raw/c0f6fd948c527afd132fdc476e1d3f0a9c5dd5fb/docs/BWC_Settings-2.png)
1. Select between 
  * Generate coupons mannually
  * Generate coupons automatically on complete order status
  * Generate coupons automatically on processing order status 

2. Define the content and layout of the coupon delivery email
  * [order_id] - available in the editor view mode
  * [customer] - available in the editor view mode

3. Define email address for test emails 

4. Click "Send test e-mail" button to verify and confirm the coupon delivery email format and features

5. Click save to store the configuration


### 3. Basic setup of a coupon product to be sold
![setup_coupon](https://calantas.org/bw-coupon/raw/c0f6fd948c527afd132fdc476e1d3f0a9c5dd5fb/docs/BWC_Setup_a_coupon-1.png)
1. Select 'Product is a coupon', to define details within the dropdown sheet
2. Enter the amount of the coupons in the stock to be sold
3. Define how long the coupon will be valid (from the time of purchase).
4. Within the visual tab, you can access more placeholders and test the PDF layout
5. Click each placeholder to insert them to the email template
7. Any standard coupon WooCommerce settings are available within the editor


### 4. Purchased coupons are listed in the WooCommerce Coupons view
![setup_coupon](https://calantas.org/bw-coupon/raw/c0f6fd948c527afd132fdc476e1d3f0a9c5dd5fb/docs/BWC_after_order-coupon_list2.png)

### 5. Coupon purchase orders are listed in the WooCommerce Orders view
![setup_coupon](https://calantas.org/bw-coupon/raw/c0f6fd948c527afd132fdc476e1d3f0a9c5dd5fb/docs/BWC_after_order-order_list.png)
1. Click the order to see coupon details 
2. Click the eye-symbol to preview the coupon PDF
3. Click the envelope-symbol to resend the coupon email 

## Contributors

Please join and help to improve the poject. You can contact me via the Kallithe repository platform, at https://calantas.org/bw-coupon/


## License
GNU General Public License v3.0 -


## File Index 

| File/Folder   | Description   | Use by  |
| ------------- |:-------------:| -----:|
| admin    | Source code for the admin section | Wordpress |
| bwc.php  | Entry point for Wordpress  | Wordpress |
| bwc.png  | Logo | Wordpress/Readme  |
| .git     | Git Source Repository | Control system software  |
| .gitignore  | list of files and folders ignored by GIT | Control system software |
| includes | Source reused by the plugin | Wordpress  |
| languages | Language translations files | Wordpress  |
| lib | Third party PHP libraries |  Wordpress |
| LICENSE.txt | Important Leagal Doc | All  |
| README.md | Markdown readme-file for Source Control System | Source Control system  |
| readme.txt | Converted from README.md to a Wordpress readme-file | Wordpress  |
| make_wp_readme.sh| Script to convert the README.md to wordrpess readme.txt | Developer |
| view_README.sh | Shell script to start a webserver to review the Readme.md  in a browser| User |
| uninstall.php | Plugin uninstaller file for WordPress | Wordpress |
| docs | Docs and screenshots how to use the plugin | User |

## Developer 
### How to install
```console
apt-get install subversion
svn --force checkout https://plugins.svn.wordpress.org/bw-coupon
cd bw-coupon/trunk


```

## Credits 

* Logo (Cherubs from the Sistine Madonna) from [Raffaello Sanzio da Urbino](https://en.wikipedia.org/wiki/Raphael)
* Text from somchai@jabber.calantas.com 
* Translations from Patrice Jaquier

## Sponsors 

* https://www.merc.biz
* https://bueroloewenherz.com
